
struct appdata
{
    float4 position : POSITION;
    float3 normal : NORMAL;
    //float3 color : DIFFUSE;
    float4 diffuse : DIFFUSE;
    float2 uvs :TEXCOORD0;
    float3 tangent :TEXCOORD1;
    //
	//float3 TestColor : SPECULAR;
};





struct vfconn
{

    float4 HPOS : POSITION;
    //oat4 Nrm : NORMAL;
	float4 HCOL : COLOR;
	float4 HCOL2 : COLOR1;
    float4 oPosition : TEXCOORD1;
    float2 oUV : TEXCOORD0;
                      float3 oNormal : TEXCOORD3;

float3 oHalf : TEXCOORD4;
                                                float3 oLight : TEXCOORD2;
  
};








vfconn main(appdata IN,
                uniform float3 LightPos,
                uniform float3 CameraPos,
          uniform float3 Reduction,
          uniform float3 alpha,

uniform float4x4 ModelViewLightProj,
uniform float4x4 ModelViewObject,
			uniform float4x4 ModelViewProj)
{
    vfconn OUT;

    
//
	//ModelViewProj=mul(ModelViewProj,ModelViewObject);
    //ModelViewLightProj=mul(ModelViewLightProj,ModelViewObject);
    //ModelViewLightProj=mul(ModelViewObject,ModelViewLightProj);
IN.position.z+=alpha.x*max(0,abs(IN.position.x)-0.5);

IN.position.xyz*=2.3;
   
    IN.position=mul(ModelViewObject,IN.position);
    IN.normal=mul((float3x3   )ModelViewObject,IN.normal);
IN.tangent=mul((float3x3   )ModelViewObject,IN.tangent);
   
    OUT.oPosition=mul (ModelViewLightProj,IN.position);

    //IN.position=mul(IN.position, ModelViewObject);
    //IN.normal=mul(IN.normal,(float3x3   )ModelViewObject);
//IN.tangent=mul(IN.tangent,(float3x3   )ModelViewObject);
//IN.position.w=0;


float3 LightP=float3 (-2,1,0);

float3 L=normalize (LightP-IN.position);
float3 V=normalize (CameraPos-IN.position);
float3 H=normalize (L+V);
float4 AllWhite=float4 (0.2,0.7,1,0);

float specularL=pow (max(dot (IN.normal,H),0),14);
float diff=max (dot (IN.normal,L),0);

// spherical mapping
float3 ref=reflect (V,IN.normal);
ref.z+=1;

float m=0.1*length(ref);
m*=m*3;
m*=m;
m*=m*0.5;

m=1-max (dot (IN.normal,V),0);
m*=m*0.7;
m+=0.5;


// m=length (ref);

//m = 2(fx^2 + fy^2 + (fz + 1)^2)^(1/2). 


    //OUT.oUV=IN.uvs*0.7;

 OUT.oUV=float2 (ref.x+0.5,ref.y+0.5);
// OUT.oUV=IN.uvs;

//OUT.oUV+=float2 (1,1);

 //reflect (V,IN.normal);

//IN.position*=12;
    OUT.HPOS = mul(ModelViewProj, IN.position);

OUT.oLight=(-IN.position+LightP*1);
OUT.oNormal=IN.normal;
//OUT.oLight=H;

//normalize(IN.position-LightP);

//OUT.oNormal=
//OUT.oPos=IN.position;

//diff=pow(diff,1);

float3 binormal = cross(IN.normal,IN.tangent);


float3x3 rotation = float3x3(IN.tangent,                               binormal,                               IN.normal);
 rotation = float3x3(IN.tangent,
     binormal,
     IN.normal);
 
//float ff=length(LightP);
float mult=1/(1+0.002*length(CameraPos-IN.position)*length(CameraPos-IN.position));
mult=1;
OUT.oLight = mul(rotation, OUT.oLight);
OUT.oLight=normalize(OUT.oLight);

OUT.oLight=float3(0,0,-1);

//OUT.oNormal=(UpV*0.5)+0.5;
OUT.oHalf=mul(rotation,H);
OUT.oHalf=normalize(OUT.oHalf);
//OUT.oHalf=float3 (2,-1,0);
//distt=1;
//OUT.oPosition+=OUT.oHalf*0.1;
//distt=0;
OUT.HCOL2=1.7-3*(IN.diffuse*mult*0.29+IN.diffuse*0.9*mult*diff);
//OUT.HCOL2=1/(1+0.002*length(CameraPos-IN.position)*length(CameraPos-IN.position));
OUT.HCOL=1-20*AllWhite*specularL;

OUT.HCOL2=1*(IN.diffuse*mult*0.29+IN.diffuse*0.9*mult*diff);
OUT.HCOL=1*AllWhite*specularL;
OUT.HCOL2=float4(m*0.4,m*0.7,m*1.4,m);


OUT.HCOL2=float4(1,1,1,1);
//*float4 (0.3,0.7

//OUT.HCOL=AllWhite;
//OUT.HCOL2=AllWhite;


//OUT.HCOL=float4 (1,1,1,1);

//if (LightP.x<111110) OUT.HCOL.x=1;

//float g=IN.color.x;
/*
OUT.HCOL.x=0.1+diff*0.7;
OUT.HCOL.y=0.1+diff*0.9;
OUT.HCOL.z=0.1+diff*1.9;
*/

    return OUT;
} // main




























/*


  VERTEX ENV MAP



  
struct appdata
{
    float4 position : POSITION;
    float3 normal : NORMAL;
    float3 color : DIFFUSE;
    float3 TestColor : SPECULAR;
};

struct vfconn
{
    float4 HPOS : POSITION;
    float2 oPosition : TEXCOORD0;
    float2 oNormal : TEXCOORD1;
};

vfconn main(appdata IN,
            uniform float3 Kd,
            uniform float4x4 ModelViewProj)
{
    vfconn OUT;

    

	OUT.HPOS = mul(ModelViewProj, IN.position);
float3 normal=mul((float3x3)ModelViewProj,IN.normal);
normalize(normal);


float4 normpos=normalize(OUT.HPOS);
float3 refl=reflect (normal,normpos);


float magn=1.5*sqrt (refl.x*refl.x+refl.y*refl.y+(refl.z+1)*(refl.z+1));






float4 normpos2=normalize(IN.position);
float3 refl2=reflect (IN.normal,normpos);


float magn2=1.5*sqrt (refl2.x*refl2.x+refl2.y*refl2.y+(refl2.z+1)*(refl2.z+1));




//diss/=length(diss);


//float cl=dot (normal,diss-OUT.HPOS);
OUT.oNormal.x=refl.x/magn+0.5;
OUT.oNormal.y=refl.y/magn+0.5;


//normalize(diss);

OUT.oPosition.x=IN.position.x*2;
OUT.oPosition.y=IN.position.y*2;

//OUT.oNormal.x=normal.x*0.3;
//OUT.oNormal.y=normal.y*0.3;

    return OUT;
} // main

 */
